Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureTypeOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureTypeOperation.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureTypeOperation.java	(revision 43114)
@@ -65,6 +65,18 @@
         return true;
     }
     
+    protected String getDatabase() {
+        return this.dbname;
+    }
+    
+    protected String getSchema() {
+        return this.schema;
+    }
+    
+    protected String getTablename() {
+        return this.table;
+    }
+    
     public void fetch(
             EditableFeatureType featureType,
             Connection conn,
@@ -106,7 +118,7 @@
             boolean firstGeometryAttrFound = false;
             for (i = 1; i <= rsMetadata.getColumnCount(); i++) {
                 attr = getAttributeFromMetadata(featureType, conn, rsMetadata, i);
-                if (pks != null && pks.contains(attr.getName())) {
+                if ( isInPrimaryKeys(pks,attr) ) {
                     attr.setIsPrimaryKey(true);
                 }
                 if (attr.getType() == DataTypes.GEOMETRY) {
@@ -122,10 +134,6 @@
 
             }
 
-            if (geometriesColumns > 0) {
-                fetch_CRS_and_shapeType(conn, rsMetadata, featureType, schema, table);
-            }
-
             if (defaultGeometryColumn == null && geometriesColumns == 1) {
                 featureType.setDefaultGeometryAttributeName(lastGeometry);
             }
@@ -142,6 +150,10 @@
         }
     }
 
+    protected boolean isInPrimaryKeys(List<String> pks, EditableFeatureAttributeDescriptor attr) {
+        return pks != null && pks.contains(attr.getName());
+    }
+    
     protected List<String> getPrimaryKeysFromMetadata(
             Connection conn,
             String catalog,
@@ -286,28 +298,12 @@
                 );
                 break;
             case DataTypes.GEOMETRY:
-                this.fetchGeometryType(attr, rsMetadata, colIndex);
+                this.fetchGeometryTypeAndSRS(attr, rsMetadata, colIndex);
                 break;
         }
         return attr;
     }
 
-    protected void fetchGeometryType(
-            EditableFeatureAttributeDescriptor attr,
-            ResultSetMetaData rsMetadata,
-            int colIndex
-        ) {
-        try {
-            GeometryType geomType = GeometryLocator.getGeometryManager().getGeometryType(
-                    Geometry.TYPES.GEOMETRY,
-                    Geometry.SUBTYPES.GEOM2D
-            );
-            attr.setGeometryType(geomType);
-        } catch (Exception ex) {
-            logger.warn("Can't get default geometry type.",ex);
-        }
-    }
-    
     protected int getDataTypeFromMetadata(
             ResultSetMetaData rsMetadata,
             int colIndex
@@ -369,15 +365,31 @@
         }
     }
 
-    protected void fetch_CRS_and_shapeType(
-            Connection conn,
+    /**
+     * Inicializa el tipo, subtipo y SRS del attributo de tipo geometria.
+     * 
+     * @param attr
+     * @param rsMetadata
+     * @param colIndex 
+     */
+    protected void fetchGeometryTypeAndSRS(
+            EditableFeatureAttributeDescriptor attr,
             ResultSetMetaData rsMetadata,
-            EditableFeatureType featureType,
-            String schema,
-            String table
-        ) throws SQLException {
-
-        // Nothing to do
+            int colIndex
+        ) {
+        if( attr.getType()!=DataTypes.GEOMETRY ) {
+            return;
+        }
+        try {
+            GeometryType geomType = GeometryLocator.getGeometryManager().getGeometryType(
+                    Geometry.TYPES.GEOMETRY,
+                    Geometry.SUBTYPES.GEOM2D
+            );
+            attr.setGeometryType(geomType);
+            attr.setSRS(null);
+        } catch (Exception ex) {
+            logger.warn("Can't get default geometry type.",ex);
+        }
     }
-
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CreateTableOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CreateTableOperation.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CreateTableOperation.java	(revision 43114)
@@ -13,6 +13,7 @@
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
+import org.gvsig.fmap.geom.DataTypes;
 
 public class CreateTableOperation extends AbstractConnectionOperation {
 
@@ -65,16 +66,26 @@
         JDBCSQLBuilderBase sqlbuilder = this.createSQLBuilder();
         sqlbuilder.create_table().table().database(dbName).schema(schemaName).name(tableName);
         for (FeatureAttributeDescriptor attr : type) {
-            sqlbuilder.create_table().add_column(
-                    attr.getName(),
-                    attr.getType(),
-                    attr.getSize(),
-                    attr.getPrecision(),
-                    attr.isPrimaryKey(),
-                    attr.allowNull(),
-                    attr.isAutomatic(),
-                    attr.getDefaultValue()
-            );
+            if( attr.getType()==DataTypes.GEOMETRY ) {
+                sqlbuilder.create_table().add_geometry_column(
+                        attr.getName(),
+                        attr.getGeomType().getType(),
+                        attr.getGeomType().getSubType(),
+                        attr.getSRS(),
+                        attr.allowNull()
+                );
+            } else {
+                sqlbuilder.create_table().add_column(
+                        attr.getName(),
+                        attr.getType(),
+                        attr.getSize(),
+                        attr.getPrecision(),
+                        attr.isPrimaryKey(),
+                        attr.allowNull(),
+                        attr.isAutomatic(),
+                        attr.getDefaultValue()
+                );
+            }
         }
         for (Pair<String, SQLBuilder.Privilege> roleAndPrivilege : rolesAndPrivileges) {
             sqlbuilder.grant().role(roleAndPrivilege.getLeft()).privilege(roleAndPrivilege.getRight());
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java	(revision 43114)
@@ -6,6 +6,7 @@
 import java.sql.ResultSet;
 import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.IProjection;
+import org.gvsig.fmap.crs.CRSFactory;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.exception.InitializeException;
@@ -334,6 +335,16 @@
         int id = Integer.parseInt(ss[1]);
         return id;
     }
+
+    @Override
+    public IProjection getProjectionFromSRSId(int srsid) {
+        // Dumb implementation
+        if( srsid < 2000 ) {
+            return null;
+        }
+        IProjection proj = CRSFactory.getCRS("EPSG:"+srsid);
+        return proj;
+    }
     
     @Override
     public JDBCStoreProvider createProvider(
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCHelper.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCHelper.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCHelper.java	(revision 43114)
@@ -159,6 +159,8 @@
     ) throws InitializeException;
 
     public int getSRSCode(IProjection crs);
+    
+    public IProjection getProjectionFromSRSId(int srsid);
 
     public JDBCNewStoreParameters createNewStoreParameters();
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/DefaultJDBCConnectionPanelView.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/DefaultJDBCConnectionPanelView.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/DefaultJDBCConnectionPanelView.java	(revision 43114)
@@ -9,6 +9,7 @@
 import java.awt.Dimension;
 import javax.swing.Box;
 import javax.swing.ImageIcon;
+import javax.swing.JButton;
 import javax.swing.JComboBox;
 import javax.swing.JFrame;
 import javax.swing.JLabel;
@@ -29,10 +30,11 @@
    JComboBox cboConnectors = new JComboBox();
    JTextField txtServer = new JTextField();
    JTextField txtPort = new JTextField();
-   JTextField txtDataBase = new JTextField();
    JTextField txtUsername = new JTextField();
    JTextField txtPassword = new JTextField();
    JLabel lblFoother = new JLabel();
+   JTextField txtDataBase = new JTextField();
+   JButton btnDataBaseBrowser = new JButton();
 
    /**
     * Default constructor
@@ -170,9 +172,6 @@
       txtPort.setName("txtPort");
       jpanel1.add(txtPort,cc.xy(4,8));
 
-      txtDataBase.setName("txtDataBase");
-      jpanel1.add(txtDataBase,cc.xy(4,10));
-
       txtUsername.setName("txtUsername");
       jpanel1.add(txtUsername,cc.xy(4,12));
 
@@ -180,6 +179,7 @@
       jpanel1.add(txtPassword,cc.xy(4,14));
 
       jpanel1.add(createPanel1(),cc.xywh(2,16,3,1));
+      jpanel1.add(createPanel2(),cc.xy(4,10));
       addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17 });
       return jpanel1;
    }
@@ -199,6 +199,25 @@
       return jpanel1;
    }
 
+   public JPanel createPanel2()
+   {
+      JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      txtDataBase.setName("txtDataBase");
+      jpanel1.add(txtDataBase,cc.xy(1,1));
+
+      btnDataBaseBrowser.setActionCommand("...");
+      btnDataBaseBrowser.setName("btnDataBaseBrowser");
+      btnDataBaseBrowser.setText("...");
+      jpanel1.add(btnDataBaseBrowser,cc.xy(2,1));
+
+      addFillComponents(jpanel1,new int[0],new int[0]);
+      return jpanel1;
+   }
+
    /**
     * Initializer
     */
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/DefaultJDBCConnectionPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/DefaultJDBCConnectionPanel.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/DefaultJDBCConnectionPanel.java	(revision 43114)
@@ -6,16 +6,21 @@
 package org.gvsig.fmap.dal.swing.impl.jdbc;
 
 import java.awt.Dimension;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
 import java.awt.event.ItemEvent;
 import java.awt.event.ItemListener;
+import java.io.File;
 import java.util.Iterator;
 import java.util.List;
 import javax.swing.ComboBoxModel;
 import javax.swing.JComponent;
 import javax.swing.JLabel;
 import javax.swing.JTextField;
+import javax.swing.SwingUtilities;
 import javax.swing.plaf.basic.BasicHTML;
 import javax.swing.text.View;
+import org.apache.commons.lang3.ArrayUtils;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataFactory;
@@ -24,10 +29,15 @@
 import org.gvsig.fmap.dal.DataServerExplorerPool;
 import org.gvsig.fmap.dal.DataServerExplorerPoolEntry;
 import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemStoreParameters;
 import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
 import org.gvsig.fmap.dal.swing.jdbc.JDBCConnectionPanel;
 import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dynobject.DynClass;
+import org.gvsig.tools.dynobject.DynField;
 import org.gvsig.tools.i18n.I18nManager;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.threadsafedialogs.ThreadSafeDialogsManager;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
@@ -81,13 +91,29 @@
         this.cboConnections.addItemListener(new ItemListener() {
             @Override
             public void itemStateChanged(ItemEvent e) {
-                onChangeConnection();
+                // Lo hago asi para evitar cuelgues durante la depuracion
+                // al poner puntos de ruptura en un evento de un combo.
+                SwingUtilities.invokeLater(new Runnable() {
+
+                    @Override
+                    public void run() {
+                        onChangeConnection();
+                    }
+                });
             }
         });
         this.cboConnectors.addItemListener(new ItemListener() {
             @Override
             public void itemStateChanged(ItemEvent e) {
-                onChangeConnector();
+                // Lo hago asi para evitar cuelgues durante la depuracion
+                // al poner puntos de ruptura en un evento de un combo.
+                SwingUtilities.invokeLater(new Runnable() {
+
+                    @Override
+                    public void run() {
+                        onChangeConnector();
+                    }
+                });
             }
         });
         try {
@@ -98,6 +124,13 @@
             logger.warn("Can't fill combos",th);
         }
         this.translate();
+        this.btnDataBaseBrowser.addActionListener(new ActionListener() {
+
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                onBrowseDatabase();
+            }
+        });
         adjustPreferedHeight(this.lblFoother,300);
     }
 
@@ -147,6 +180,20 @@
         this.txtDataBase.setText(parameters.getDBName());
         this.txtUsername.setText(parameters.getUser());
         this.txtPassword.setText(parameters.getPassword());
+        
+        DynClass definition = parameters.getDynClass();
+        
+        DynField field = definition.getDynField(JDBCServerExplorerParameters.HOST_PARAMTER_NAME);
+        this.txtServer.setEnabled( !( field.isReadOnly() || field.isHidden() ));
+        field = definition.getDynField(JDBCServerExplorerParameters.PORT_PARAMTER_NAME);
+        this.txtPort.setEnabled( !( field.isReadOnly() || field.isHidden() ));
+        field = definition.getDynField(JDBCServerExplorerParameters.DBNAME_PARAMTER_NAME);
+        this.txtDataBase.setEnabled( !( field.isReadOnly() || field.isHidden() ));
+        field = definition.getDynField(JDBCServerExplorerParameters.USER_PARAMTER_NAME);
+        this.txtUsername.setEnabled( !( field.isReadOnly() || field.isHidden() ));
+        field = definition.getDynField(JDBCServerExplorerParameters.PASSWORD_PARAMTER_NAME);
+        this.txtPassword.setEnabled( !( field.isReadOnly() || field.isHidden() ));
+        this.btnDataBaseBrowser.setVisible(parameters instanceof FilesystemStoreParameters);
     }
 
     @Override
@@ -351,4 +398,21 @@
         this.txtUsername.setText("");
         this.txtPassword.setText("");
     }
+    
+    private void onBrowseDatabase() {
+        if( this.forcedParameters==null ) {
+            return;
+        }
+        ThreadSafeDialogsManager dlgmanager = ToolsSwingLocator.getThreadSafeDialogsManager();
+        I18nManager i18nManager = ToolsLocator.getI18nManager();
+        File[] files = dlgmanager.showOpenFileDialog(
+                i18nManager.getTranslation("_Select_database"), 
+                null
+        );
+        if( ArrayUtils.isEmpty(files) ) {
+            return;
+        }
+        ((FilesystemStoreParameters)this.forcedParameters).setFile(files[0]);
+        this.txtDataBase.setText(this.forcedParameters.getDBName());
+    }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/SQLBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/SQLBuilder.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/SQLBuilder.java	(revision 43114)
@@ -1,6 +1,7 @@
 package org.gvsig.fmap.dal;
 
 import java.util.List;
+import org.cresques.cts.IProjection;
 
 public interface SQLBuilder extends ExpressionBuilder {
     
@@ -75,6 +76,33 @@
         public boolean has_database();
         public boolean has_schema();
     }
+    
+    public interface ColumnDescriptorBuilder {
+        public String getName();
+        public int getType();
+        public int getSize();
+        public int getPrecision();
+        public boolean isPrimaryKey();
+        public boolean isAutomatic();
+        boolean allowNulls();
+        public Object getDefaultValue();
+        public int getGeometryType();
+        public int getGeometrySubtype();
+        public int getGeometrySRSId();
+        public boolean isGeometry();
+        
+        public void setName(String name);
+        public void setType(int type);
+        public void setSize(int size);
+        public void setPrecision(int precision);
+        public void setIsPrimaryKey(boolean isPk);
+        public void setIsAutomatic(boolean isAutomatic);
+        public void setAllowNulls(boolean allowNulls);
+        public void setDefaultValue(Object defaultValue);
+        public void setGeometryType(int geom_type);
+        public void setGeometrySubtype(int geom_subtype);
+        public void setGeometrySRSId(int geom_srsid);
+    }
 
     public interface CountBuilder extends Value {
         public CountBuilder all();
@@ -194,6 +222,8 @@
     public interface CreateTableBuilder extends Statement {
         public TableNameBuilder table();
         public CreateTableBuilder add_column(String columnName, int type, int type_p, int type_s, boolean isPk, boolean allowNulls, boolean isAutomatic, Object defaultValue);
+        public CreateTableBuilder add_geometry_column(String columnName, int geom_type, int geom_subtype, IProjection proj, boolean allowNulls);
+        public ColumnDescriptorBuilder getColumnDescriptor(String columnName);
         public List<String> toStrings();
     }
     
@@ -228,7 +258,11 @@
     public String default_schema();
 
     public String sqltype(int dataType, int p, int s);
+    
+    public Object sqlgeometrytype(int type, int subtype);
 
+    public Object sqlgeometrydimension(int type, int subtype);
+    
     public SelectBuilder select();
     
     public UpdateBuilder update();
